# HistoryData.AWK 
# This file creates Historical data for SPC 
# C. McKenna 9/8/95 
# 
BEGIN{ 
 
 
	# Fields are seperated by ~  
	FS="~" 
 
	# DEBUG printf toggle 
	DEBUG=0 
 
	output_file = ARGV[2] 
 
	delete ARGV[2] 
 
	if (DEBUG) 
		printf("output file name is "  output_file "\n") 
 
	#remove destination files 
	rm_string = sprintf("rm -f %s", output_file) 
 
	system (rm_string) 
 
} 
 
# Start of main processing 
 
{ 
 
	if (DEBUG) 
		printf("\n processing record "  NR " \n") 
 
	if ($0 == "") 
	next	 
 
	if (DEBUG) 
		printf ("The record is " $0 "\n") 
 
 
	# Get all fields and assign them to variables 
 
	char_no = $1 
	if (DEBUG) 
	{ 
		printf("Characteristic number is " char_no"\n") 
	} 
 
	machine_no = $2 
	if (DEBUG) 
	{ 
		printf("Machine number is " machine_no"\n") 
	} 
 
	measurement = $3 
	if (DEBUG) 
	{ 
		printf("Measurement is " measurement"\n") 
	} 
 
	job_measurement_id = $4 
	if (DEBUG) 
	{ 
		printf("Job Measurement ID is " job_measurement_id"\n") 
	} 
 
	subgroup_no = $5 
	if (DEBUG) 
	{ 
		printf("Subgroup Number  is " subgroup_no"\n") 
	} 
 
	subgroup_index = $6 
	if (DEBUG) 
	{ 
		printf("Subgroup Index  is " subgroup_index"\n") 
	} 
 
	subgroup_size = $7 
	if (DEBUG) 
	{ 
		printf("Subgroup Size  is " subgroup_size"\n") 
	} 
 
	SPCsrv_time = $8 
	if (DEBUG) 
	{ 
		printf("SPCsrv time is " SPCsrv_time"\n") 
	} 
 
	AlarmID_sequence_no = $9 
	if (DEBUG) 
	{ 
		printf("Alarm ID Sequence number is " AlarmID_sequence_no"\n") 
	} 
 
	cause_code = $10 
	if (DEBUG) 
	{ 
		printf("Cause code is " cause_code "\n") 
	} 
 
	corrective_action  = $11 
	if (DEBUG) 
	{ 
		printf("Corrective Action is " corrective_action "\n") 
	} 
 
	comment = $12 
	if (DEBUG) 
	{ 
		printf("comment is  " comment "\n") 
	} 
 
	graph_type = $13 
	if (DEBUG) 
	{ 
		printf("graph type is " graph_type "\n") 
	} 
 
	rule_type = $14 
	if (DEBUG) 
	{ 
		printf("rule type is " rule_type "\n") 
	} 
 
 
 
	# if data for same measurement number 
	 
	if (measurement_no == current_meas_no) 
	{ 
		count = count + 1 
	} 
 
	current_meas_no = measurement_no 
 
	current_subgroup_no = subgroup_no 
 
	total_subgroup_size = subgroup_size 
 
 
 
 
 
	# Output SPCsrv data command to output file 
	printf("data %s.%s.Data ch=Data %s time=%s \n", char_no, machine_no, measurement, 
SPCsrv_time) >> output_file 
 
	# If record contains a non-null alarm sequence id, then create a SPCsrv plusdata command 
	if (AlarmID_sequence_no != "?") 
	{ 
 
		plusdata_string = sprintf("Cause Code:            %s", cause_code)  
		printf("plusdata %s.%s.%s ch=%s time=%s \"%s\" \n", char_no, machine_no, graph_type, 
graph_type, SPCsrv_time, plusdata_string) >> output_file 
 
		plusdata_string = sprintf("Correct. Action:       %s",  corrective_action)  
		printf("plusdata %s.%s.%s ch=%s time=%s \"%s\" \n", char_no, machine_no, graph_type, 
graph_type, SPCsrv_time, plusdata_string) >> output_file 
 
		plusdata_string = sprintf("Comment:               %s", comment)  
		printf("plusdata %s.%s.%s ch=%s time=%s \"%s\" \n", char_no, machine_no, graph_type, 
graph_type, SPCsrv_time, plusdata_string) >> output_file 
 
		plusdata_string = sprintf("Rule Type  %s", rule_type)  
		printf("plusdata %s.%s.%s ch=%s time=%s \"%s\" \n", char_no, machine_no, graph_type, 
graph_type, SPCsrv_time, plusdata_string) >> output_file 
		 
	} 
 
} #end of main processing 
 
END { 
 
		# change the permission on the file to "rw" 
	 
		chmod_cmd=sprintf("chmod 666 %s", output_file) 
 
		system(chmod_cmd) 
} 
  


