#	Program:	readListJobData.AWK
#
#	Author:         Dave Femia
#                       Integral Engineering
#                       dfemia@integral.usa1.com
#                       508.448.2894 (Pager 800.592.0933)
#
#       Date:           Rev.1           August 8, 1995
#
#       Purpose:        Open both the ..../Jobs/item.op.RAW and
#                       ..../Machines/item.op.RAW files and create the
#                       following:
#                               1)      CELLman internal data structures
#                               2)      RT_DATAsrv initial characteristics index tables
#				3) 	WINsrv port and data collection windows
#
#START BEGIN
BEGIN{
	FS="~"
	i = 1
	while(getline < "Chars.SED"> 0 ) {

		ITEM_NO[i]		= $1
		PROCESS_REV_NO[i]	= $2
		OPER_NO[i]		= $3
		PLAN_REV_NO[i]		= $4
		STEP_NO[i]		= $5
		STEP_DESC[i]		= $6
		CLASS[i]		= $7
		SUB_SIZE[i]		= $8
		GAGE_NAME[i]		= $9
		GAGE_NO[i]		= $10
		CHANNEL[i]		= $11
		NUM_CHARS[i]		= $12
		PORT_ID[i]		= $13
		BAUD_RATE[i]		= $14
		DATABITS[i]		= $15
		STOP_BITS[i]		= $16
		PARITY[i]		= $17
		START_STRING[i]		= $18
		STOP_STRING[i]		= $19
		EOM[i]			= $20
		DEC_PL[i]		= $21
		TAPE_NO[i]		= $22
		UPPER_SPEC[i]		= $23
		LOWER_SPEC[i]		= $24
		NOMINAL_VALUE[i]	= $25
		NOMINAL_UNITS[i]	= $26
		UPPER_FLYER[i]		= $27
		LOWER_FLYER[i]		= $28
		TARGET_VALUE[i]		= $29
		NO_MEAS[i]		= $30
		PRE_UCL[i]		= $31
		PRE_LCL[i]		= $32
		SPC[i]			= $33
		DATA_COLLECT[i]		= $34
		MEAS_ID[i]		= $35
		OPER_SUFX[i]		= $36

		ACTUAL_USL[i]		= NOMINAL_VALUE[i] + UPPER_SPEC[i]
		ACTUAL_LSL[i]		= NOMINAL_VALUE[i] - LOWER_SPEC[i]

		DIFF[i]			= ( ACTUAL_USL[i] - ACTUAL_LSL[i] ) / 2.0

		if ( UPPER_FLYER[i] == "null" ) {
			ACTUAL_UP_FLY[i]        = NOMINAL_VALUE[i] + (1.5 * DIFF[i])
			}
		else
			{
			ACTUAL_UP_FLY[i]        = NOMINAL_VALUE[i] + UPPER_FLYER[i]
			}

		if ( LOWER_FLYER[i] == "null" ) {
			ACTUAL_UP_FLY[i]        = NOMINAL_VALUE[i] - (1.5 * DIFF[i])
			}
		else
			{
			ACTUAL_LOW_FLY[i]       = NOMINAL_VALUE[i] - LOWER_FLYER[i]
			} 

		
		printf("USL: %s NOM: %s LSL: %s UFL: %s LFL:%s \n",ACTUAL_USL[i],NOMINAL_VALUE[i],ACTUAL_LSL[i],ACTUAL_UP_FLY[i],ACTUAL_LOW_FLY[i] )

		++i
	}
	GROUP = 1
}
#END BEGIN
######################################################################################
# Main
{

#	Send msgs to CELLman to create data structures

	for(i = 1; i <= CNT; ++i)
		{

                        trace = sprintf("CWtrace -n trace1 Sending group messaage %s ", i )
                        system(trace)

			MSG = sprintf("\$CELLworks\/FASTech\/CELLworks\/bin\/mbx_put -n %s %s group=%s step_no=%s mach_no=%s plan_rev=%s port_id=%s meas_id=%s num_chrs=%s sub_sz=%s gage=%s \\\"%s\\\" \\\"%s\\\" ", MBX, REPLYBOX, GROUP, STEP_NO[i], $1, PLAN_REV_NO[i], PORT_ID[i], MEAS_ID[i], NUM_CHARS[i], SUB_SIZE[i], GAGE_NO[i], $3, STEP_DESC[i]  )
			printf(MSG "\n")
			system(MSG)
		}

#	Create WINsrv Machine button list window

	if( NR == 1) {

		yOffset		=	2
		yDelta		=	9

		winMachs	=	sprintf("%s/MachView.WIN", UIdir )
		chmod		=	sprintf("chmod 666 %s", winMachs )
		remove		=	sprintf("rm %s", winMachs )
		system(remove)

		print("\n")	>	winMachs
		system(chmod)
	}

	y	=	yOffset + ( ( GROUP - 1) * yDelta )

	button = sprintf("add button winMachines btnMach_%s \"label=%s - %s\" type=normal x=3 y=%s dx=5 dy=1 cx=ctxBigElementPrim accelerator=%s \"shell=\$CELLworks\/FASTech\/CELLworks\/bin\/mbx_put -n %s UIReplyMenu winChoose lstUpdateMach %s \" \n\n", GROUP, GROUP, $1, y, GROUP, MBX, GROUP )

	printf(button)	
	printf(button)	>>	winMachs
	
	++GROUP
}
# End Main
#####################################################################################
END{

#	CREATE THE RT_DATAsrv Characteristic Records

	insertData   = sprintf("%s/DataTableSetup.RTDS", UIdir )
	remove  = sprintf("rm %s", insertData )
	chmod	= sprintf("chmod 666 %s", insertData )
	system(remove)
	print(" \n") 	> 	insertData	
	system(chmod)

        for(i = 1; i <= CNT; ++i)
        {
		for (j = 1; j <= 7; j++ )
		{
			insert = sprintf("insert into tblDataOut_%s (sub_idx, step_no, data_type) values (%s, %s, \'V\') \n", j,j,STEP_NO[i] )
			print(insert)	>>	insertData
			if( i == 1) {
				sub1 = sprintf("subscribe dataRaw_%s tblDataOut_%s sub_cnt SENDTO RTDBsrv REPLYTO ReplyFilteredData UPDATE FORMAT \'updt name=raw_data.%%step_no%% value=%%var_result%%\' where ack=NACK \n", j, j )
				print(sub1)	>>	insertData

				sub2 = sprintf("subscribe dataBox_%s tblDataOut_%s sub_cnt SENDTO RTDBsrv REPLYTO ReplyFilteredData UPDATE FORMAT \'updt name=init.%%step_no%% value=OFF \' \n", j, j )
				print(sub2)	>>	insertData
				sub3 = sprintf("subscribe dataFilter_%s tblDataOut_%s sub_cnt SENDTO RTDBsrv REPLYTO ReplyFilteredData UPDATE FORMAT \'fetcht name=data.%%step_no%% \' where ack=NACK\n", j, j )
				print(sub3)	>>	insertData

#				sub4 = sprintf("subscribe a_%s tblDataOut_%s sub_cnt SENDTO SPCsrv REPLYTO RT_DATAsrv UPDATE FORMAT \'rule %%step_no%%.%%mach_no%%.Data ch=Data name=Time type=custom count=0 outof=0 mbx=RT_DATAsrv \"msg=update tblDataOut_%s set spc_time=\\\'$T\\\' where $K[grp_info]\" \' where ack=ACK\n", j, j, j )
#				print(sub4)	>>	insertData

				sub5 = sprintf("subscribe dataSPC_%s tblDataOut_%s sub_cnt SENDTO SPCsrv REPLYTO RT_DATAsrv UPDATE FORMAT \'data %%step_no%%.%%mach_no%%.Data ch=Data %%var_result%% \"grp_info step_no=%%step_no%% \" \' where ack=ACK\n", j, j  )
				print(sub5)	>>	insertData

				sub6 = sprintf("subscribe insertSQL_%s tblDataOut_%s spc_time SENDTO SQLmgr_insert REPLYTO ReplySQLmgr_insert UPDATE FORMAT \'insert: sqcs_qual_outs %%sub_idx%% %%sub_cnt%% %%sub_run_sa%% %%data_type%% %%meas_loc%% %%var_result%% %%att_result%% %%serial_no%% %%sub_type%% %%mach_no%% %%stat_no%% %%emp_id%% %%no_inspect%% %%no_reject%% %%heat_code%% %%data_status%% %%spc_time%% \' where spc_time IS NOT NULL\n", j, j, MBX, j )
				print(sub6)	>>	insertData

			}
		}
	}

#	CREATE THE WINsrv DATA COLLECTION SCREEN

	yOffSet	= 9
	winDC   = sprintf("%s/DataView.WIN", UIdir )
	remove  = sprintf("rm %s", winDC )
	chmod	= sprintf("chmod 666 %s", winDC )
	system(remove)
	print(" \n") 	>	winDC
	system(chmod)

        for(i = 1; i <= CNT; ++i)
        {

		y    =	yOffSet * (i - 1)
		yp2  =	y + 2

		boxChar  = sprintf("add box winDataCollect boxCharOutline_%s x=0 y=%s dx=220 dy=9 cx=ctxDataBoxNormal border=1 margin=0 \n", STEP_NO[i], y )
		txtDesc  = sprintf("add text winDataCollect txtDesc_%s x=28 y=%s \"string=%s\" justify=left cx=ctxBigElementPrim \n", STEP_NO[i], yp2, substr(STEP_DESC[i],1,40) )
		boxValue = sprintf("add box winDataCollect boxValue_%s x=188 y=%s dx=32 dy=9 cx=ctxWindowPrim border=0 margin=0 \n", STEP_NO[i], y )
		boxAlarm = sprintf("add box winDataCollect boxAlarm_%s x=0 y=%s dx=25 dy=9 cx=ctxWindowPrim border=0 margin=0 \n", STEP_NO[i], y )
		btnChar  = sprintf("add button winDataCollect btnAlarm_%s label=%s x=3 y=%s dx=3 dy=1 cx=ctxBigElementPrim \n", STEP_NO[i], STEP_NO[i], yp2 )
		fldValue = sprintf("add field winDataCollect fldValue_%s length=8 x=192 y=%s dx=4 cx=ctxBigElementScnd input=FLOat access=acsNeverOn \n", STEP_NO[i], yp2 )
		fldSpec  = sprintf("add field winDataCollect fldSpec_%s length=7 x=159 y=%s dx=4 cx=ctxBigElementPrim input=NOInput value=%s \n", STEP_NO[i], yp2, substr(NOMINAL_VALUE[i],1,7) )
		btnValue = sprintf("add button winDataCollect btnValue_%s label= x=192 y=%s dx=4 dy=1 cx=ctxBigElementScndDepr access=\n", STEP_NO[i], yp2 )

		printf(boxChar) 	>>	winDC 
		printf(txtDesc) 	>>	winDC 
		printf(boxValue) 	>>	winDC 
		printf(boxAlarm) 	>>	winDC 
		printf(btnChar) 	>>	winDC 
		printf(fldValue) 	>>	winDC 
		printf(fldSpec) 	>>	winDC 
		printf(btnValue) 	>>	winDC 
		printf("\n")		>>	winDC

	}
#	End of 'for' loop...


#	CREATE THE WINsrv PORT SETUP SCREEN

	CNT_LINES = 0
	yOffSet	= 6
	CNT_PORT = 1
	LAST_PORT = "NULL VALUE"
	LAST_GAGE = "NULL VALUE"
	LAST_CHAR = "NULL VALUE"
	CNT_CHARS = 0

	winGP   = sprintf("%s/GagePortView.WIN", UIdir )
	remove  = sprintf("rm %s", winGP )
	chmod	= sprintf("chmod 666 %s", winGP )
	system(remove)
	print(" \n") 	>	winGP
	system(chmod)

        for(i = 1; i <= CNT; ++i)
        {

		CNT_LINES = CNT_LINES + 1
		y    =	yOffSet * (CNT_LINES  - 1)
		yp1  =	y + 1
		yp2  =	y + 2

#		PORT ELEMENTS

		boxNewPort	= sprintf("add  box winGagePorts box_%s x=0 y=%s dx=221 dy=0 cx=ctxDataBoxNormal border=1 margin=0 \n", PORT_ID[i], y )
		txtPortID	= sprintf("add text winGagePorts txtPort_%s x=10 y=%s \"string=Port  %s:    %s\" justify=left cx=ctxElementPrim \n", PORT_ID[i], yp1, CNT_PORT, PORT_ID[i] )
		txtPortStat	= sprintf("add text winGagePorts txtStat_%s x=61 y=%s string=OFF justify=right cx=ctxElementPrim \n", CNT_PORT, yp1 )
		btnPortID	= sprintf("add button winGagePorts btnPort_%s label= x=4 y=%s dx=1 dy=y cx=ctxPortOff style=roundbox \n", CNT_PORT, yp2 )
		txtCharID	= sprintf("add text winGagePorts txtCharID_%s x=94 y=%s \"string=Char No\" justify=center cx=ctxElementPrim \n", PORT_ID[i], yp1 )
		txtDesc		= sprintf("add text winGagePorts txtDesc_%s x=111 y=%s \"string=Characteristic Description\" justify=left cx=ctxElementPrim \n", PORT_ID[i], yp1 )
		txtGageExt	= sprintf("add text winGagePorts txtGagExt_%s x=75 y=%s \"string=Gage Ext\" justify=center cx=ctxElementPrim \n", PORT_ID[i], yp1 )


		printf("i: %s  y: %s \n", i, y )
		printf("Last Port: %s  This Port: %s \n", LAST_PORT, PORT_ID[i] )
		if( PORT_ID[i] != LAST_PORT ) {

#			Populate tblPorts in RT_DATAsrv

			MSG = sprintf("\$CELLworks\/FASTech\/CELLworks\/bin\/mbx_put -n %s RT_DATAsrv update tblPorts set port_id=\\\'%s\\\', baud=%s, stopbits=%s, parity=\\\'%s\\\', eom=\\\'%s\\\', databits=%s, start_string=\\\'%s\\\', stop_string=\\\'%s\\\' where cmd_mailbox=\\\'port%s\\\' ", MBX, PORT_ID[i], BAUD_RATE[i], STOP_BITS[i], PARITY[i], EOM[i], DATABITS[i], START_STRING[i], STOP_STRING[i], CNT_PORT )

			printf(MSG "\n")
			system(MSG)

			printf("Ports not equal for i value: %s \n", i )
			CNT_CHARS = 0
			LAST_PORT = PORT_ID[i]
			CNT_PORT = CNT_PORT + 1

			printf(txtPortID)	>>	winGP
			printf(txtPortStat)	>>	winGP
			printf(btnPortID)	>>	winGP
			printf(txtCharID)	>>	winGP
			printf(txtDesc)		>>	winGP
			printf(txtGageExt)	>>	winGP
			printf(boxNewPort)	>>	winGP
			printf("\n")		>>	winGP

			CNT_LINES = CNT_LINES + 1
			y    =	yOffSet * (CNT_LINES  - 1)
			yp1  =	y + 1
			yp2  =	y + 2
		}


#		GAGE ELEMENTS

		fldExt		= sprintf("add  field winGagePorts fldExt_%s.%s length=2 x=71 y=%s dx=2 cx=ctxElementScnd input=ANY \n", PORT_ID[i], GAGE_NO[i], y ) 
		btnGage		= sprintf("add  button winGagePorts btnGage_%s.%s \"label=%s\" x=4 y=%s dx=15 dy=1 cx=ctxElementPrim \n", PORT_ID[i], MEAS_ID[i], GAGE_NAME[i], y )


		printf("Gage No.:  %s \n", GAGE_NO[i] )

		if( GAGE_NO[i] != LAST_GAGE ) {

			printf("Gages not equal for i value %s  and y: %s \n", i, y )
			CNT_CHARS = 0
			LAST_GAGE = GAGE_NO[i]

			printf(fldExt)		>>	winGP
			printf(btnGage)		>>	winGP
			printf("\n")		>>	winGP

		}


#		CHARACTERISTIC ELEMEMTS

		CNT_CHARS = CNT_CHARS + 1
		printf("Char NO.:  %s \n", CNT_CHARS )

		fldChDesc	= sprintf("add  field winGagePorts fldChDes_%s.%s.%s length=28 x=112 y=%s dx=28 cx=ctxElementPrim \"value=%s\" input=NOInput \n", PORT_ID[i], MEAS_ID[i], CNT_CHARS, y, substr(STEP_DESC[i],1,40) )
		btnCharNum	= sprintf("add  button winGagePorts btnChar_%s.%s.%s x=89 y=%s dx=3 dy=1 cx=ctxElementPrim label=%s \n", PORT_ID[i], MEAS_ID[i], CNT_CHARS, y, STEP_NO[i] )


		printf(fldChDesc)		>>	winGP
		printf(btnCharNum)		>>	winGP
		printf("\n")			>>	winGP

	}
#	End of 'for' Loop

# Message to CELLman to inform of Data Collection window completion.
	MSG = sprintf("\$CELLworks\/FASTech\/CELLworks\/bin\/mbx_put -n %s %s //c 0 Job Data Setup Completed.", MBX, REPLYBOX )
	printf(MSG "\n")
	system(MSG)

        trace = sprintf("CWtrace -n trace1 Job complete message sent.")
        system(trace)
 


}
